//provides chain mute controls for the drum rack

autowatch = 1;

var mutes = new Array();
mutes.length = 9;
var pnames = new Object();
var values = new Array();
var initpath = 'this_device canonical_parent devices 1 chains 0'; //first drum pad
//path live_set tracks 0 devices 1 chains <pad#>

function makelinks(){
    post("\nlinking to chain mutes");
    for(var i=0;i<mutes.length;i++){
        mutes[i]=new LiveAPI(callback);
        initpath = 'this_device canonical_parent devices 1 chains '+i;
        mutes[i].path = initpath;
        //var thename = mutes[i].get("name"); //for whatever reason, the chains are not reliably providing a name.
        var iplusone=i+1;
        var thename = "chainmute["+iplusone+"]";
        mutes[i].name = thename;
        post("\nmutename",thename);
        pnames[thename]=i; //associate the index from name;
        //watch:
        mutes[i].property = "mute";
    }
}

function update(p,v){
    //get the index that the parameter name corresponds to:
    var i = pnames[p];
    if(i>=0){
        mutes[i].set("mute",v);
    }
}

function callback(args){
    //post("\ncallback arrived from", this, ":", args);
    if (this.name && args[0]=="mute"){
        //post("\nupdate",this.name);
        var sendto = this.patcher.getnamed(this.name);
        sendto.message(args[1]);
    }
}


function gitprop(prop){
    post("\ngetting",mutes.length);
    for(var i=0;i<mutes.length;i++){
        var got=mutes[i].get(prop);
        post("\nprop",prop,got);
    }
}