autowatch = 1;
outlets=3;
var seq = new Object;
seq.pitch = new Array();
seq.velocity = new Array();
seq.duration = new Array();
seq.extra1 = new Array();
seq.stepenable = new Array();

var buf = new Object;
buf.pitch = new Array();
buf.velocity = new Array();
buf.duration = new Array();
buf.extra1 = new Array();
buf.stepenable = new Array();

var sub = new Object;
sub.pitch = new Array();
sub.velocity = new Array();
sub.duration = new Array();
sub.extra1 = new Array();
sub.stepenable = new Array();

var params=new Array();
params = ["pitch","velocity","duration","extra1","stepenable"]; 

var DEBUG = 0;

//store what comes in, pass it thru
function anything(){
        var ob = messagename;
        var a = arrayfromargs(arguments);
        seq[ob]=a;
        outlet(0,ob,a);
        if(DEBUG) post("\nin",ob,a);
}

//break into chunks of "sub_size" sub-arrays, then rotate the sub-arrays to the left or right
//dir is direction, 1 is right, 0 is left;
//e.g., a left rotation and a subsize of 4:
//0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15
//becomes
//1 2 3 0 5 6 7 4 9 10 11 8 13 14 15 12

function rot(dir,sub_size){
    //clear buffer and initialize components as new array:
    buf = new Object;
    for(p in params){
        var t=params[p];
        buf[t]=new Array();
    }
    
    var chunk = sub_size; //length of sub
    var toend = 0;
    var groups = seq.pitch.length/chunk; //number of subs
    
    for(var i=0;i<groups;i++){
        var mins= i*chunk;
        var maxs = mins+(chunk);
        //post("\nmm",mins,maxs,chunk,groups);
        for(p in params){
            var t=params[p];
            sub[t] = seq[t].slice(mins,maxs);
        }
        //The shift() method removes the first element of an array, and returns that element.
        switch(dir){
            case 0: //left shift
                for(p in params){
                    var t=params[p];
                    //post("\nL",t,sub[t],"....");
                    toend=sub[t].shift();//remove the first element and store it
                    sub[t].push(toend); //then add it to the end
                    //post("postrot:",sub[t]);
                }
            break;
            case 1: //right shift
                for(p in params){
                    var t=params[p];
                    toend=sub[t].pop();//remove the first element and store it
                    sub[t].unshift(toend); //then add it to the end
                }
            break;
        }
        //need to work in the subchunks to the mains...
        for(var j=0;j<chunk;j++){    
            var themin= j*chunk;
            themax = themin+(chunk);
            for(p in params){
                var t=params[p];
                buf[t][mins+j]=sub[t][j];
            }
        } 
    }
    for(p in params){
        var t=params[p];
        seq[t]=buf[t].slice(0);
        if(t!="stepenable"){
            //post("\nrot_done",t,seq[t]);
            outlet(0,t,seq[t]);
        }else{
            //post("\nrot_done@",t,seq[t]);
            
            //because the enables are run through a different system - not the live.step - I have to do some other gymnastics to get the UI and pattrs updated for the enables.
            //this closes a gate so we don't get feedback from the stepenable message
            outlet(2,0);
            //this updates the pattrs and the UI objects via thispatcher:
            dumpenables();
        }
    } 
    //post("\n******");
}
 
function dumpenables(){
    //send stepenable info out a bit differently than we do with the other parameters:
    for(var i=0;i<seq.stepenable.length;i++){
        var iandone = i+1;
        //could also go to pattrstorage, I suppose:
        outlet(1,"script","send","enable["+iandone+"]",seq.stepenable[i]);
        outlet(0,"stepenable",seq["stepenable"]);
    }
    outlet(2,1);
}
dumpenables.immediate = 0;