//latches the ADSR and Pitch/Vol/Pan/Filter knobs to the selected chain's device controls.

autowatch = 1;

var knobs = new Array();
knobs.length = 9;
var pnames = new Object();
var values = new Array();
var initpath = 'this_device canonical_parent devices 1 chains 0 devices 0 parameters 1'; //default is first knob in first device in first chain (note: parameter 0 is Device On switch)
//path live_set tracks 0 devices 1 chains <pad#> devices 0 parameters <a,d,s,r,pitch,vol,pan,filter>

function makelinks(pad){
    post("\nlinking to chain",pad,"devices ctls");
    for(var i=0;i<knobs.length;i++){
        //var iplusone=i+1;
        knobs[i]=new LiveAPI(callback);
        initpath = 'this_device canonical_parent devices 1 chains '+pad+' devices 0 parameters '+i;
        knobs[i].path = initpath;
        //var thename = knobs[i].get("name");
        var thename = "enc["+i+"]";
        knobs[i].name = thename;
        pnames[thename]=i; //associate the index from name;
        //values[i] = knobs[i].get("value");
        //watch:
        knobs[i].property = "value";
    }
}

function update(p,v){
    //get the index that the parameter name corresponds to:
    var i = pnames[p];
    if(i>=0){
        if(p!==updatingnow){
            //post("\nupd:",p,"-",updatingnow);
            knobs[i].set("value",v);
        }
        updatingnow="";//feeback protect
    }
}

var updatingnow = ""; //feedback protect
function callback(args){
    //post("\ncallback arrived from", this, ":", args);
    if (this.name && args[0]=="value"){
        //post("\nCB",this.name);
        updatingnow=this.name;//feedbackprotect
        var sendto = this.patcher.getnamed(this.name);
        sendto.message(args[1]);
    }
}

function gitprop(prop){
    post("\ngetting",knobs.length);
    for(var i=0;i<knobs.length;i++){
        var got=knobs[i].get(prop);
        post("\nprop",prop,got);
    }
}